import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListEarthObservationJobInputFilterSensitiveLog, ListEarthObservationJobOutputFilterSensitiveLog, } from "../models/models_0";
import { de_ListEarthObservationJobsCommand, se_ListEarthObservationJobsCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class ListEarthObservationJobsCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("SageMakerGeospatial", "ListEarthObservationJobs", {})
    .n("SageMakerGeospatialClient", "ListEarthObservationJobsCommand")
    .f(ListEarthObservationJobInputFilterSensitiveLog, ListEarthObservationJobOutputFilterSensitiveLog)
    .ser(se_ListEarthObservationJobsCommand)
    .de(de_ListEarthObservationJobsCommand)
    .build() {
}
