import { HostHeaderInputConfig, HostHeaderResolvedConfig } from "@aws-sdk/middleware-host-header";
import { UserAgentInputConfig, UserAgentResolvedConfig } from "@aws-sdk/middleware-user-agent";
import { RegionInputConfig, RegionResolvedConfig } from "@smithy/config-resolver";
import { EndpointInputConfig, EndpointResolvedConfig } from "@smithy/middleware-endpoint";
import { RetryInputConfig, RetryResolvedConfig } from "@smithy/middleware-retry";
import { HttpHandlerUserInput as __HttpHandlerUserInput } from "@smithy/protocol-http";
import { Client as __Client, DefaultsMode as __DefaultsMode, SmithyConfiguration as __SmithyConfiguration, SmithyResolvedConfiguration as __SmithyResolvedConfiguration } from "@smithy/smithy-client";
import { AwsCredentialIdentityProvider, BodyLengthCalculator as __BodyLengthCalculator, CheckOptionalClientConfig as __CheckOptionalClientConfig, ChecksumConstructor as __ChecksumConstructor, Decoder as __Decoder, Encoder as __Encoder, HashConstructor as __HashConstructor, HttpHandlerOptions as __HttpHandlerOptions, Logger as __Logger, Provider as __Provider, Provider, SdkStreamMixinInjector as __SdkStreamMixinInjector, StreamCollector as __StreamCollector, UrlParser as __UrlParser, UserAgent as __UserAgent } from "@smithy/types";
import { HttpAuthSchemeInputConfig, HttpAuthSchemeResolvedConfig } from "./auth/httpAuthSchemeProvider";
import { DeleteEarthObservationJobCommandInput, DeleteEarthObservationJobCommandOutput } from "./commands/DeleteEarthObservationJobCommand";
import { DeleteVectorEnrichmentJobCommandInput, DeleteVectorEnrichmentJobCommandOutput } from "./commands/DeleteVectorEnrichmentJobCommand";
import { ExportEarthObservationJobCommandInput, ExportEarthObservationJobCommandOutput } from "./commands/ExportEarthObservationJobCommand";
import { ExportVectorEnrichmentJobCommandInput, ExportVectorEnrichmentJobCommandOutput } from "./commands/ExportVectorEnrichmentJobCommand";
import { GetEarthObservationJobCommandInput, GetEarthObservationJobCommandOutput } from "./commands/GetEarthObservationJobCommand";
import { GetRasterDataCollectionCommandInput, GetRasterDataCollectionCommandOutput } from "./commands/GetRasterDataCollectionCommand";
import { GetTileCommandInput, GetTileCommandOutput } from "./commands/GetTileCommand";
import { GetVectorEnrichmentJobCommandInput, GetVectorEnrichmentJobCommandOutput } from "./commands/GetVectorEnrichmentJobCommand";
import { ListEarthObservationJobsCommandInput, ListEarthObservationJobsCommandOutput } from "./commands/ListEarthObservationJobsCommand";
import { ListRasterDataCollectionsCommandInput, ListRasterDataCollectionsCommandOutput } from "./commands/ListRasterDataCollectionsCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "./commands/ListTagsForResourceCommand";
import { ListVectorEnrichmentJobsCommandInput, ListVectorEnrichmentJobsCommandOutput } from "./commands/ListVectorEnrichmentJobsCommand";
import { SearchRasterDataCollectionCommandInput, SearchRasterDataCollectionCommandOutput } from "./commands/SearchRasterDataCollectionCommand";
import { StartEarthObservationJobCommandInput, StartEarthObservationJobCommandOutput } from "./commands/StartEarthObservationJobCommand";
import { StartVectorEnrichmentJobCommandInput, StartVectorEnrichmentJobCommandOutput } from "./commands/StartVectorEnrichmentJobCommand";
import { StopEarthObservationJobCommandInput, StopEarthObservationJobCommandOutput } from "./commands/StopEarthObservationJobCommand";
import { StopVectorEnrichmentJobCommandInput, StopVectorEnrichmentJobCommandOutput } from "./commands/StopVectorEnrichmentJobCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "./commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "./commands/UntagResourceCommand";
import { ClientInputEndpointParameters, ClientResolvedEndpointParameters, EndpointParameters } from "./endpoint/EndpointParameters";
import { RuntimeExtension, RuntimeExtensionsConfig } from "./runtimeExtensions";
export { __Client };
/**
 * @public
 */
export type ServiceInputTypes = DeleteEarthObservationJobCommandInput | DeleteVectorEnrichmentJobCommandInput | ExportEarthObservationJobCommandInput | ExportVectorEnrichmentJobCommandInput | GetEarthObservationJobCommandInput | GetRasterDataCollectionCommandInput | GetTileCommandInput | GetVectorEnrichmentJobCommandInput | ListEarthObservationJobsCommandInput | ListRasterDataCollectionsCommandInput | ListTagsForResourceCommandInput | ListVectorEnrichmentJobsCommandInput | SearchRasterDataCollectionCommandInput | StartEarthObservationJobCommandInput | StartVectorEnrichmentJobCommandInput | StopEarthObservationJobCommandInput | StopVectorEnrichmentJobCommandInput | TagResourceCommandInput | UntagResourceCommandInput;
/**
 * @public
 */
export type ServiceOutputTypes = DeleteEarthObservationJobCommandOutput | DeleteVectorEnrichmentJobCommandOutput | ExportEarthObservationJobCommandOutput | ExportVectorEnrichmentJobCommandOutput | GetEarthObservationJobCommandOutput | GetRasterDataCollectionCommandOutput | GetTileCommandOutput | GetVectorEnrichmentJobCommandOutput | ListEarthObservationJobsCommandOutput | ListRasterDataCollectionsCommandOutput | ListTagsForResourceCommandOutput | ListVectorEnrichmentJobsCommandOutput | SearchRasterDataCollectionCommandOutput | StartEarthObservationJobCommandOutput | StartVectorEnrichmentJobCommandOutput | StopEarthObservationJobCommandOutput | StopVectorEnrichmentJobCommandOutput | TagResourceCommandOutput | UntagResourceCommandOutput;
/**
 * @public
 */
export interface ClientDefaults extends Partial<__SmithyConfiguration<__HttpHandlerOptions>> {
    /**
     * The HTTP handler to use or its constructor options. Fetch in browser and Https in Nodejs.
     */
    requestHandler?: __HttpHandlerUserInput;
    /**
     * A constructor for a class implementing the {@link @smithy/types#ChecksumConstructor} interface
     * that computes the SHA-256 HMAC or checksum of a string or binary buffer.
     * @internal
     */
    sha256?: __ChecksumConstructor | __HashConstructor;
    /**
     * The function that will be used to convert strings into HTTP endpoints.
     * @internal
     */
    urlParser?: __UrlParser;
    /**
     * A function that can calculate the length of a request body.
     * @internal
     */
    bodyLengthChecker?: __BodyLengthCalculator;
    /**
     * A function that converts a stream into an array of bytes.
     * @internal
     */
    streamCollector?: __StreamCollector;
    /**
     * The function that will be used to convert a base64-encoded string to a byte array.
     * @internal
     */
    base64Decoder?: __Decoder;
    /**
     * The function that will be used to convert binary data to a base64-encoded string.
     * @internal
     */
    base64Encoder?: __Encoder;
    /**
     * The function that will be used to convert a UTF8-encoded string to a byte array.
     * @internal
     */
    utf8Decoder?: __Decoder;
    /**
     * The function that will be used to convert binary data to a UTF-8 encoded string.
     * @internal
     */
    utf8Encoder?: __Encoder;
    /**
     * The runtime environment.
     * @internal
     */
    runtime?: string;
    /**
     * Disable dynamically changing the endpoint of the client based on the hostPrefix
     * trait of an operation.
     */
    disableHostPrefix?: boolean;
    /**
     * Unique service identifier.
     * @internal
     */
    serviceId?: string;
    /**
     * Enables IPv6/IPv4 dualstack endpoint.
     */
    useDualstackEndpoint?: boolean | __Provider<boolean>;
    /**
     * Enables FIPS compatible endpoints.
     */
    useFipsEndpoint?: boolean | __Provider<boolean>;
    /**
     * The AWS region to which this client will send requests
     */
    region?: string | __Provider<string>;
    /**
     * Setting a client profile is similar to setting a value for the
     * AWS_PROFILE environment variable. Setting a profile on a client
     * in code only affects the single client instance, unlike AWS_PROFILE.
     *
     * When set, and only for environments where an AWS configuration
     * file exists, fields configurable by this file will be retrieved
     * from the specified profile within that file.
     * Conflicting code configuration and environment variables will
     * still have higher priority.
     *
     * For client credential resolution that involves checking the AWS
     * configuration file, the client's profile (this value) will be
     * used unless a different profile is set in the credential
     * provider options.
     *
     */
    profile?: string;
    /**
     * The provider populating default tracking information to be sent with `user-agent`, `x-amz-user-agent` header
     * @internal
     */
    defaultUserAgentProvider?: Provider<__UserAgent>;
    /**
     * Default credentials provider; Not available in browser runtime.
     * @deprecated
     * @internal
     */
    credentialDefaultProvider?: (input: any) => AwsCredentialIdentityProvider;
    /**
     * Value for how many times a request will be made at most in case of retry.
     */
    maxAttempts?: number | __Provider<number>;
    /**
     * Specifies which retry algorithm to use.
     * @see https://docs.aws.amazon.com/AWSJavaScriptSDK/v3/latest/Package/-smithy-util-retry/Enum/RETRY_MODES/
     *
     */
    retryMode?: string | __Provider<string>;
    /**
     * Optional logger for logging debug/info/warn/error.
     */
    logger?: __Logger;
    /**
     * Optional extensions
     */
    extensions?: RuntimeExtension[];
    /**
     * The {@link @smithy/smithy-client#DefaultsMode} that will be used to determine how certain default configuration options are resolved in the SDK.
     */
    defaultsMode?: __DefaultsMode | __Provider<__DefaultsMode>;
    /**
     * The internal function that inject utilities to runtime-specific stream to help users consume the data
     * @internal
     */
    sdkStreamMixin?: __SdkStreamMixinInjector;
}
/**
 * @public
 */
export type SageMakerGeospatialClientConfigType = Partial<__SmithyConfiguration<__HttpHandlerOptions>> & ClientDefaults & UserAgentInputConfig & RetryInputConfig & RegionInputConfig & HostHeaderInputConfig & EndpointInputConfig<EndpointParameters> & HttpAuthSchemeInputConfig & ClientInputEndpointParameters;
/**
 * @public
 *
 *  The configuration interface of SageMakerGeospatialClient class constructor that set the region, credentials and other options.
 */
export interface SageMakerGeospatialClientConfig extends SageMakerGeospatialClientConfigType {
}
/**
 * @public
 */
export type SageMakerGeospatialClientResolvedConfigType = __SmithyResolvedConfiguration<__HttpHandlerOptions> & Required<ClientDefaults> & RuntimeExtensionsConfig & UserAgentResolvedConfig & RetryResolvedConfig & RegionResolvedConfig & HostHeaderResolvedConfig & EndpointResolvedConfig<EndpointParameters> & HttpAuthSchemeResolvedConfig & ClientResolvedEndpointParameters;
/**
 * @public
 *
 *  The resolved configuration interface of SageMakerGeospatialClient class. This is resolved and normalized from the {@link SageMakerGeospatialClientConfig | constructor configuration interface}.
 */
export interface SageMakerGeospatialClientResolvedConfig extends SageMakerGeospatialClientResolvedConfigType {
}
/**
 * <p>Provides APIs for creating and managing SageMaker geospatial resources.</p>
 * @public
 */
export declare class SageMakerGeospatialClient extends __Client<__HttpHandlerOptions, ServiceInputTypes, ServiceOutputTypes, SageMakerGeospatialClientResolvedConfig> {
    /**
     * The resolved configuration of SageMakerGeospatialClient class. This is resolved and normalized from the {@link SageMakerGeospatialClientConfig | constructor configuration interface}.
     */
    readonly config: SageMakerGeospatialClientResolvedConfig;
    constructor(...[configuration]: __CheckOptionalClientConfig<SageMakerGeospatialClientConfig>);
    /**
     * Destroy underlying resources, like sockets. It's usually not necessary to do this.
     * However in Node.js, it's best to explicitly shut down the client's agent when it is no longer needed.
     * Otherwise, sockets might stay open for quite a long time before the server terminates them.
     */
    destroy(): void;
}
